ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.19 by root, Sun Apr 1 00:36:35 2007 UTC vs.
Revision 1.45 by root, Tue Jul 24 22:49:41 2007 UTC

6my $exec_prefix = "@exec_prefix@"; 6my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 7my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 8my $DATADIR = "@datadir@/@PACKAGE@";
9 9
10my $CONVERT = "@CONVERT@"; 10my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 11#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 12my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 13my $RSYNC = "@RSYNC@";
14my $PNGNQ = "@PNGNQ@";
14 15
15use Getopt::Long; 16use Getopt::Long;
16use Coro::Event; 17use Coro::Event;
17use AnyEvent; 18use AnyEvent;
18use IO::AIO (); 19use IO::AIO ();
20use Crossfire; 21use Crossfire;
21use Coro; 22use Coro;
22use Coro::AIO; 23use Coro::AIO;
23use POSIX (); 24use POSIX ();
24use Digest::MD5; 25use Digest::MD5;
26use Carp;
25use Storable; $Storable::canonical = 1; 27use Coro::Storable; $Storable::canonical = 1;
28
29$SIG{QUIT} = sub { Carp::cluck "QUIT" };
26 30
27sub usage { 31sub usage {
28 warn <<EOF; 32 warn <<EOF;
29Usage: cfutil [-v] [-q] [--force] [--cache] 33Usage: cfutil [-v] [-q] [--force] [--cache]
30 [--install-arch path] 34 [--install-arch path]
42my $CACHE = 0; 46my $CACHE = 0;
43my $FORCE; 47my $FORCE;
44my $TMPDIR = "/tmp/cfutil$$~"; 48my $TMPDIR = "/tmp/cfutil$$~";
45my $TMPFILE = "aaaa0"; 49my $TMPFILE = "aaaa0";
46 50
51our %COLOR = (
52 black => 0,
53 white => 1,
54 navy => 2,
55 red => 3,
56 orange => 4,
57 blue => 5,
58 darkorange => 6,
59 green => 7,
60 lightgreen => 8,
61 grey => 9,
62 brown => 10,
63 gold => 11,
64 tan => 12,
65);
66
47END { system "rm", "-rf", $TMPDIR } 67END { system "rm", "-rf", $TMPDIR }
48 68
49Event->signal (signal => "INT", cb => sub { exit 1 }); 69Event->signal (signal => "INT", cb => sub { exit 1 });
50Event->signal (signal => "TERM", cb => sub { exit 1 }); 70Event->signal (signal => "TERM", cb => sub { exit 1 });
51 71
68} 88}
69 89
70sub inst_maps($) { 90sub inst_maps($) {
71 my (undef, $path) = @_; 91 my (undef, $path) = @_;
72 92
73 print "installing '$path' to '$DATADIR/maps'\n"; 93 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
74 94
75 if (!-f "$path/regions") { 95 if (!-f "$path/regions") {
76 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 96 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
77 exit 1 unless $FORCE; 97 exit 1 unless $FORCE;
78 } 98 }
79 99
80 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded" 100 system $RSYNC, "-a", "--chmod=u=rwX,go=rX", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"
81 and die "map installation failed.\n"; 101 and die "map installation failed.\n";
82 102
83 print "maps installed successfully.\n"; 103 print "maps installed successfully.\n";
84} 104}
85 105
86{ 106{
107 our %ANIMINFO;
87 our %FACEINFO; 108 our %FACEINFO;
109 our %RESOURCE;
88 our @ARC; 110 our @ARC;
111 our %ARC;
89 our $TRS; 112 our $TRS;
90 our $NFILE; 113 our $NFILE;
91 our %ANIM; 114 our $PATH;
92 115
93 our $QUANTIZE = "+dither -colorspace RGB -colors 256"; 116 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
94 117
95 our (@png, @trs, @arc); # files we are interested in 118 our (@png, @trs, @arc, @res); # files we are interested in
96 119
97 sub commit_png($$$) { 120 sub commit_png($$$) {
98 my ($name, $data, $T) = @_; 121 my ($name, $data, $T) = @_;
99 122
100 $FACEINFO{$name}{"data$T"} = $data; 123 $FACEINFO{$name}{"data$T"} = $data;
147 # possibly enlarge 170 # possibly enlarge
148 if (0 > aio_stat "$stem.64x64.png") { 171 if (0 > aio_stat "$stem.64x64.png") {
149 my $other = "$stem.64x64.png~"; 172 my $other = "$stem.64x64.png~";
150 173
151 if (0 > aio_lstat $other or (-M _) > (-M $path)) { 174 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
152 warn "rescale $other\n";#d#
153 my $wrap = 0; # for the time being 175 my $wrap = 0; # for the time being
154 fork_sub { 176 fork_sub {
155 system "convert png:\Q$path\E -depth 8 rgba:-" 177 system "convert png:\Q$path\E -depth 8 rgba:-"
156 . "| $exec_prefix/bin/cfhq2xa $w $h $wrap" 178 . "| $exec_prefix/bin/cfhq2xa $w $h $wrap"
157 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $QUANTIZE -quality 00 png32:\Q$other\E~" 179 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $QUANTIZE -quality 00 png32:\Q$other\E~"
158 and die "convert/hq2xa pipeline error: status $? ($!)"; 180 and die "convert/hq2xa pipeline error: status $? ($!)";
159 system $OPTIPNG, "-o5", "-i0", "-q", "$other~"; 181 system $OPTIPNG, "-i0", "-q", "$other~";
160 die "$other~ has zero size, aborting." unless -s "$other~"; 182 die "$other~ has zero size, aborting." unless -s "$other~";
161 rename "$other~", $other; 183 rename "$other~", $other;
162 }; 184 };
163 } 185 }
164 186
170 my $other = "$stem.32x32.png~"; 192 my $other = "$stem.32x32.png~";
171 193
172 if (0 > aio_lstat $other or (-M _) > (-M $path)) { 194 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
173 fork_sub { 195 fork_sub {
174 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~"; 196 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
175 system $OPTIPNG, "-o5", "-i0", "-q", "$other~"; 197 system $OPTIPNG, "-i0", "-q", "$other~";
198
199 # reduce smoothfaces >10000 bytes
200 if ($stem =~ /_S\./ && (-s "$other~") > 10000) {
201 my $ncolor = 256;
202 while () {
203 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
204 system $OPTIPNG, "-i0", "-q", "$other~~";
205 last if 10000 > -s "$other~~";
206 $ncolor = int $ncolor * 0.9;
207 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
208 }
209
210 printf "reduced %s from %d to %d bytes using %d colours.\n",
211 $other, -s "$other~", -s "$other~~", $ncolor
212 if $VERBOSE >= 2;
213 rename "$other~~", "$other~";
214 }
215
176 die "$other~ has zero size, aborting." unless -s "$other~"; 216 die "$other~ has zero size, aborting." unless -s "$other~";
177 rename "$other~", $other; 217 rename "$other~", $other;
178 }; 218 };
179 } 219 }
180 220
181 warn "scaled down $path to $other\n";#d# 221 #warn "scaled down $path to $other\n";#d#
182
183 push @png, [$other, !$CACHE]; 222 push @png, [$other, !$CACHE];
184 } 223 }
185 } 224 }
186 225
187 (my $face = $stem) =~ s/^.*\///; 226 (my $face = $stem) =~ s/^.*\///;
188 227
228 # split all bigfaces, but avoid smoothfaces (*_S)
189 if (($w > $T || $h > $T) && $face !~ /_S\./) { 229 if (($w > $T || $h > $T) && $face !~ /_S\./) {
190 # split 230 # split
191 my @tile; 231 my @tile;
192 for my $x (0 .. (int $w / $T) - 1) { 232 for my $x (0 .. (int $w / $T) - 1) {
193 for my $y (0 .. (int $h / $T) - 1) { 233 for my $y (0 .. (int $h / $T) - 1) {
257 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 297 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
258 298
259 my $arc = read_arch "$dir/$file"; 299 my $arc = read_arch "$dir/$file";
260 for my $o (values %$arc) { 300 for my $o (values %$arc) {
261 push @ARC, $o; 301 push @ARC, $o;
302 for (my $m = $o; $m; $m = $m->{more}) {
303 $ARC{$m->{_name}} = $m;
304 }
262 305
263 $o->{editor_folder} = $dir; 306 $o->{editor_folder} = $dir;
264 307
265 my $visibility = delete $o->{visibility}; 308 my $visibility = delete $o->{visibility};
266 my $magicmap = delete $o->{magicmap}; 309 my $magicmap = delete $o->{magicmap};
277 my $x = $o->{x} - $dx; 320 my $x = $o->{x} - $dx;
278 my $y = $o->{y} - $dy; 321 my $y = $o->{y} - $dy;
279 322
280 my $ext = $x|$y ? "+$x+$y" : ""; 323 my $ext = $x|$y ? "+$x+$y" : "";
281 324
282 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/; 325 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
283 326
284 my $visibility = delete $o->{visibility} if exists $o->{visibility}; 327 $visibility = delete $o->{visibility} if exists $o->{visibility};
285 my $magicmap = delete $o->{magicmap} if exists $o->{magicmap}; 328 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
286 329
287 my $anim = delete $o->{anim}; 330 my $anim = delete $o->{anim};
288 331
289 if ($anim) { 332 if ($anim) {
333 # possibly add $ext to the animation name to avoid
334 # the need to specify archnames for all parts
335 # of a multipart archetype.
290 $o->{animation} = "$o->{_name}"; 336 $o->{animation} = "$o->{_name}";
337 my $facings = 1;
338 my @frames;
291 339
292 for (@$anim) { 340 for (@$anim) {
293 $_ .= $ext unless /^facings\s|^blank.x11$|^empty.x11$/; 341 if (/^facings\s+(\d+)/) {
342 $facings = $1*1;
343 } elsif (/^blank.x11$|^empty.x11$/) {
344 push @frames, $_;
345 } else {
346 push @frames, "$_$ext";
347 }
294 } 348 }
295 349
296 $ANIM{"$o->{_name}$ext"} = 350 $ANIMINFO{$o->{animation}} = {
297 join "", map "$_\n", 351 facings => $facings,
298 "anim $o->{_name}", 352 frames => \@frames,
299 @$anim, 353 };
300 "mina";
301 } 354 }
302 355
303 for my $face ($o->{face} || (), @{$anim || []}) { 356 for my $face ($o->{face} || (), @{$anim || []}) {
304 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/; 357 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/;
305 358
308 $info->{visibility} = $visibility if defined $visibility; 361 $info->{visibility} = $visibility if defined $visibility;
309 $info->{magicmap} = $magicmap if defined $magicmap; 362 $info->{magicmap} = $magicmap if defined $magicmap;
310 } 363 }
311 364
312 if (my $smooth = delete $o->{smoothface}) { 365 if (my $smooth = delete $o->{smoothface}) {
313 my ($face, $smooth) = split /\s+/, $smooth; 366 my %kv =split /\s+/, $smooth;
314 # skip empty_S.x11, it seems to server no purpose whatsoever 367 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
315 # but increases bandwidth demands and worse. 368 while (my ($face, $smooth) = each %kv) {
316 unless ($smooth eq "empty_S.x11") {
317 $FACEINFO{$face}{smooth} = $smooth; 369 $FACEINFO{$face}{smooth} = $smooth;
370 $FACEINFO{$face}{smoothlevel} = $level;
318 } 371 }
319 } 372 }
320 } 373 }
321 } 374 }
322 } 375 }
335 388
336 $TRS .= $trs; 389 $TRS .= $trs;
337 } 390 }
338 } 391 }
339 392
393 my %FILECACHE;
394
395 sub load_cached($;$) {
396 unless (exists $FILECACHE{$_[0]}) {
397 my $data;
398 if (0 < aio_load $_[0], $data) {
399 $data = $_[1]->($data)
400 if $_[1];
401 }
402
403 $FILECACHE{$_[0]} = $data;
404 }
405
406 $FILECACHE{$_[0]}
407 }
408
409 sub process_res {
410 while (@res) {
411 my ($dir, $file, $type) = @{pop @res};
412
413 my $data;
414 aio_load "$dir/$file", $data;
415
416 my $meta = load_cached "$dir/meta", sub { JSON::XS::from_json shift };
417
418 $file =~ s/\.res$//;
419 $file =~ /\.(ogg|wav|jpg|png)$/;
420
421 substr $dir, 0, 1 + length $PATH, "";
422
423 $meta = {
424 %{ $meta->{"" } || {} },
425 %{ $meta->{$file} || {} },
426 };
427
428 $RESOURCE{"$dir/$file"} = {
429 type => (delete $meta->{type}) || $type,
430 data => $data,
431 chksum => (Digest::MD5::md5 $data),
432 %$meta ? (meta => $meta) : (),
433 };
434 }
435 }
436
340 sub find_files; 437 sub find_files;
341 sub find_files { 438 sub find_files {
342 my ($path) = @_; 439 my ($path) = @_;
343 440
344 IO::AIO::aioreq_pri 4; 441 IO::AIO::aioreq_pri 4;
346 my ($dirs, $nondirs) = @_; 443 my ($dirs, $nondirs) = @_;
347 444
348 find_files "$path/$_" 445 find_files "$path/$_"
349 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 446 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs;
350 447
448 my $dir = $path;
449 substr $dir, 0, 1 + length $PATH, "";
450
351 for my $file (@$nondirs) { 451 for my $file (@$nondirs) {
452 if ($dir =~ /^music(?:\/|$)/) {
453 push @res, [$path, $file, 3] # FT_MUSIC
454 if $file =~ /\.(ogg)$/;
455
456 } elsif ($dir =~ /^sounds(?:\/|$)/) {
457 push @res, [$path, $file, 5] # FT_SOUND
458 if $file =~ /\.(wav|ogg)$/;
459
460 } elsif ($dir =~ /^res(?:\/|$)/) {
461 push @res, [$path, $file, 0] # FT_FACE
462 if $file =~ /\.(jpg|png)$/;
463 push @res, [$path, $file, 7] # FT_RSRC
464 if $file =~ /\.(res)$/;
465
352 if ($file =~ /\.png$/) { 466 } elsif ($file =~ /\.png$/) {
353 push @png, ["$path/$file", 0]; 467 push @png, ["$path/$file", 0];
468
354 } elsif ($file =~ /\.trs$/) { 469 } elsif ($file =~ /\.trs$/) {
355 push @trs, [$path, $file]; 470 push @trs, [$path, $file];
471
356 } elsif ($file =~ /\.arc$/) { 472 } elsif ($file =~ /\.arc$/) {
357 push @arc, [$path, $file]; 473 push @arc, [$path, $file];
474
358 } else { 475 } else {
359 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 476 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
360 } 477 }
361 } 478 }
362 }; 479 };
363 } 480 }
364 481
365 sub inst_arch($) { 482 sub inst_arch($) {
366 my (undef, $path) = @_; 483 my (undef, $path) = @_;
367 484
485 $PATH = $path;
486
487 print "\n",
368 print "installing '$path' to '$DATADIR'\n", 488 "Installing '$path' to '$DATADIR'\n",
489 "\n",
369 "(this can take a long time if you run this\n", 490 "This can take a long time if you run this\n",
370 "for the first time or do not use --cache).\n"; 491 "for the first time or do not use --cache.\n",
492 "\n",
493 "Unless you run verbosely, all following warning\n",
494 "or error messages indicate serious problems.\n",
495 "\n";
371 496
372 if (!-d "$path/treasures") { 497 if (!-d "$path/treasures") {
373 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 498 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
374 exit 1 unless $FORCE; 499 exit 1 unless $FORCE;
375 } 500 }
380 $_->join for ( 505 $_->join for (
381 # four png crunchers work fine for my 2x smp machine 506 # four png crunchers work fine for my 2x smp machine
382 (async \&process_png), (async \&process_png), (async \&process_png), (async \&process_png), 507 (async \&process_png), (async \&process_png), (async \&process_png), (async \&process_png),
383 (async \&process_trs), (async \&process_trs), 508 (async \&process_trs), (async \&process_trs),
384 (async \&process_arc), (async \&process_arc), 509 (async \&process_arc), (async \&process_arc),
510 (async \&process_res), (async \&process_res),
385 ); 511 );
386 512
387 { 513 {
388 open my $fh, ">:utf8", "$DATADIR/animations~" 514 # remove path prefix from editor_folder
389 or die "$DATADIR/animations~: $!"; 515 substr $_->{editor_folder}, 0, 1 + length $path, ""
390 print $fh join "", map $ANIM{$_}, sort keys %ANIM 516 for values %ARC;
517
518 # resolve inherit
519 while () {
520 my $progress;
521 my $loop;
522
523 for my $o (values %ARC) {
524 if (my $other = $o->{inherit}) {
525 if (my $s = $ARC{$other}) {
526 if ($s->{inherit}) {
527 $loop = $s;
528 } else {
529 delete $o->{inherit};
530 my %s = %$s;
531 delete @s{qw(_name more name name_pl)};
532 %$o = ( %s, %$o );
533 ++$progress;
534 }
535 } else {
536 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
537 delete $ARC{$o->{_name}};
538 }
539 }
540 }
541
542 unless ($progress) {
543 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
544 if $loop;
545
546 last;
547 }
391 } 548 }
392 549
393 { 550 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
551 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
552
394 open my $fh, ">:utf8", "$DATADIR/archetypes~" 553 open my $fh, ">:utf8", "$DATADIR/archetypes~"
395 or die "$DATADIR/archetypes~: $!"; 554 or die "$DATADIR/archetypes~: $!";
396 substr $_->{editor_folder}, 0, 1 + length $path, "" for @ARC; 555 print $fh Crossfire::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
397 print $fh Crossfire::archlist_to_string \@ARC;
398 } 556 }
399 557
400 { 558 {
401 open my $fh, ">:utf8", "$DATADIR/treasures~" 559 open my $fh, ">:utf8", "$DATADIR/treasures~"
402 or die "$DATADIR/treasures~: $!"; 560 or die "$DATADIR/treasures~: $!";
406 { 564 {
407 while (my ($k, $v) = each %FACEINFO) { 565 while (my ($k, $v) = each %FACEINFO) {
408 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n"; 566 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
409 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n"; 567 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
410 568
569 length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
570 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
571
411 $v->{chksum32} = Digest::MD5::md5 $v->{data32}; 572 $v->{chksum32} = Digest::MD5::md5 $v->{data32};
412 $v->{chksum64} = Digest::MD5::md5 $v->{data64}; 573 $v->{chksum64} = Digest::MD5::md5 $v->{data64};
574
575 if (my $magicmap = $v->{magicmap}) {
576 $magicmap =~ y/A-Z_\-/a-z/d;
577 $v->{magicmap} = $COLOR{$magicmap};
578 }
413 } 579 }
414 580
415 open my $fh, ">:perlio", "$DATADIR/facedata~" 581 open my $fh, ">:perlio", "$DATADIR/facedata~"
416 or die "$DATADIR/facedata~: $!"; 582 or die "$DATADIR/facedata~: $!";
417 583
418 $FACEINFO{""} = { version => 1}; 584 print $fh freeze {
419 print $fh Storable::nfreeze \%FACEINFO; 585 version => 2,
586 faceinfo => \%FACEINFO,
587 animinfo => \%ANIMINFO,
588 resource => \%RESOURCE,
420 } 589 };
590 }
421 591
422 for (qw(archetypes facedata animations treasures)) { 592 for (qw(archetypes facedata treasures)) {
423 chmod 0644, "$DATADIR/$_~"; 593 chmod 0644, "$DATADIR/$_~";
424 rename "$DATADIR/$_~", "$DATADIR/$_" 594 rename "$DATADIR/$_~", "$DATADIR/$_"
425 or die "$DATADIR/$_: $!"; 595 or die "$DATADIR/$_: $!";
426 } 596 }
427 597

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines